<?php
    /************************************************************************/
    /* DAlbum                                                               */
    /* ===========================                                          */
    /*                                                                      */
    /* Copyright (c) 2003 by Alexei Shamov                                  */
    /* http://www.dalbum.org                                                */
    /*                                                                      */
    /* This program is free software. You can redistribute it and/or modify */
    /* it under the terms of the GNU General Public License as published by */
    /* the Free Software Foundation; either version 2 of the License.       */
    /************************************************************************/

    if (!eregi("modules.php", $_SERVER['PHP_SELF']))
        die ("You can't access this file directly...");

    // Set Nuke authentication
    include("auth.php");

    // Set variables
    $module_name = basename(dirname(__FILE__));
    define("DALBUM_EMBEDDED", "1");
    define("DALBUM_ROOT", "modules/$module_name/script");
    define("DALBUM_BROWSERROOT", "modules/$module_name/script/");

    // Save variables
    $oldg=SaveGlobals();

    // $jump=DAlbum file to display
    if (empty($jump))
        $jump="index.php";

    // verify that jump address is okay - no funny stuff
    if (!preg_match('/^[a-zA-Z0-9]*\.php$/',$jump))
        $jump="index.php";

    // we must convert &f=myfile to &file=myfile for DAlbum to get it
    $f=$_GET['file'];
    if (isset($_GET['f']))
        $_GET['file']=$_GET['f'];

    // Get DAlbum page saved into $_page variable
    $_page="";
    ob_start(create_function('$a','global $_page;$_page.=$a;'));
    require(DALBUM_ROOT . "/$jump");
    ob_end_flush();

    // Restore &file=... (whatever it was)
    $_GET['file']=$f;

    // Output the page
    if (!strstr($_page,"<"))
    {
        // Redirection or error. Only headers there - return empty page
        print $_page;
        RestoreGlobals($oldg);
        return;
    }
    else
    {
        include("header.php");
        OpenTable();

        // Cut the body out of the returned text
        if (preg_match('~<body(.+?\>)(.*)</body>~ims',$_page,$arr))
        {
            // Display it inside <DIV class="dalbumbody">
            print "<div class='dalbumbody'><div " . $arr[1];
            print $arr[2] . "</div></div>";
        }
        else
            print "<P>Internal error occured.</P><BR>" . $_page;

        // Cleanup
        RestoreGlobals($oldg);

        // No right pane in PHP nuke - DAlbum is wide enough
        $index=0;
        CloseTable();
        include("footer.php");
    }

    /////////////// Functions ///////////////////////

    // Translate dalbum page reference to PHP nuke format
    function customTranslateRef($ref)
    {
        global $name;
        if (substr($ref,0,9)=="photo.php")
            return "modules/$name/ph.php" . substr($ref,9);
        return "modules.php?name=$name&amp;jump=" . strtr($ref,array("?"=>"&amp;","file="=>"f="));
    }

    function isDAlbumKey($a)
    {
        if (strtoupper($a)==$a || (substr($a,0,1)=='_' && $a!='_template'))
            return false;
        if ($a=='db')
            return false;
        return true;
    }

    function &SaveGlobals()
    {
        $keys=array_filter(array_keys($GLOBALS), "isDAlbumKey");
        foreach ($keys as $k)
            $arr[$k]=$GLOBALS[$k];
        return $arr;
    }
    function RestoreGlobals(&$save)
    {
        $arr=array_filter(array_keys($GLOBALS), "isDAlbumKey");
        foreach ($arr as $k)
            unset($GLOBALS[$k]);
        reset($save);
        while (list($k,$v)=each($save))
            $GLOBALS[$k]=$v;
    }
?>