<?php
    /************************************************************************/
    /* DAlbum                                                               */
    /* ===========================                                          */
    /*                                                                      */
    /* Copyright (c) 2003 by Alexei Shamov                                  */
    /* http://www.dalbum.org                                                */
    /*                                                                      */
    /* This program is free software. You can redistribute it and/or modify */
    /* it under the terms of the GNU General Public License as published by */
    /* the Free Software Foundation; either version 2 of the License.       */
    /************************************************************************/

    // Check if there is a cache entry
    $module_name = basename(dirname(__FILE__));
    $curdir=strtr(dirname(__FILE__),array('\\'=>'/'));
    $cache_fname="$curdir/cache/stylesheet.css";

    if (file_exists($cache_fname))
    {
        readfile($cache_fname);
        return;
    }

    // No cached filename. Find out the used stylesheet
    $oldg=SaveGlobals();

    define("DALBUM_EMBEDDED", "1");
    define("DALBUM_ROOT",  $curdir . "/script");
    define("DALBUM_BROWSERROOT", "modules/$module_name/script/");

    require_once(DALBUM_ROOT."/include/functions.php");
    require_once(file_exists(DALBUM_ROOT."/config/config.php")?DALBUM_ROOT."/config/config.php":DALBUM_ROOT."/include/config.php");

    // Read the stylesheet
    $filename= DALBUM_ROOT . "/" . basename("$g_sStylesheet");

    $fp = @fopen($filename, "rb");
    if ($fp)
    {
        $buffer = fread($fp, filesize($filename));
        fclose($fp);

        // Replace body with .dalbumbody
        $buffer= preg_replace('~\bbody[^\.]~i','.dalbumbody ',$buffer);

        // Replace body.centered with .dalbumbody div.centered
        $buffer= preg_replace('~\bbody.~i','.dalbumbody div.',$buffer);

        // Replace font-size in % to a fixed size (need that because of fixed tables)
        $buffer= preg_replace_callback('~(font-size\s*:)(.*?%)\s*;~i','replaceFontSize',$buffer);

        // Replace "a.tab, a:xxx" with ".dalbumbody a.tab, .dalbumbody a:xxx"
        $buffer= preg_replace_callback( '~([:a-zA-Z0-9#,. \t\n]*?)\s*(\{.*?\})~msi', "repcallback", $buffer);

        // Write all that to cache
        $fp = fopen($cache_fname, "wb");
        if ($fp)
        {
            fwrite($fp,$buffer);
            fclose($fp);
        }

        // Return it to client
        print $buffer;
    }

    RestoreGlobals($oldg);

    function replaceFontSize($ft)
    {
        if (stristr((trim($ft[2])),'inherit'))
            return $ft[0];
        $n=$ft[2]+0;

        $s="";
        if ($n>=110)
            $s="12pt";
        else if ($n>=100)
            $s="10pt";
        else if ($n>=80)
            $s="9pt";
        else if ($n>=70)
            $s="8pt;";
        else if ($n>0)
            $s="1px";
        if ($s=="")
            return $ft[0];

        return $ft[1].$s.";";
    }
    function repcallback($m)
    {
        $x=split(",",trim($m[1]));
        $z=array();
        foreach ($x as $a)
        {
            if (stristr($a,"html"))
            {
                $a=preg_replace('~\bhtml~i','',$a);
            }


            if (!strstr($a,".dalbumbody"))
                $aa=".dalbumbody $a";
            else
                $aa="$a";
            $aa=trim($aa);
            if (!in_array($aa,$z))
                $z[]=$aa;

        }
        return "\n".join(",",$z)."\n".$m[2];
    }

    function isDAlbumKey($a)
    {
        if (strtoupper($a)==$a || (substr($a,0,1)=='_' && $a!='_template'))
            return false;
        if ($a=='db')
            return false;
        return true;
    }

    function &SaveGlobals()
    {
        $keys=array_filter(array_keys($GLOBALS), "isDAlbumKey");
        foreach ($keys as $k)
            $arr[$k]=$GLOBALS[$k];
        return $arr;
    }
    function RestoreGlobals(&$save)
    {
        $arr=array_filter(array_keys($GLOBALS), "isDAlbumKey");
        foreach ($arr as $k)
            unset($GLOBALS[$k]);
        reset($save);
        while (list($k,$v)=each($save))
            $GLOBALS[$k]=$v;
    }


?>
